#ifndef INCLUDED_DML_BLOWFISH
#define INCLUDED_DML_BLOWFISH

/* 5/14/05 - If changes are made to any encryption algorithms used in the engine code
   (key length, algorithm choice, different or new use of encryption)
   please contact Randy Gibbons at 206-855-4118 or randy.gibbons@office.xerox.com.
   He is responsible for keeping track of encryption in products and
   updating the government of its use. */

/*
dml_blowfish.h:  Header file for dml_blowfish.c

Copyright (C) 1997 by Paul Kocher

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


See blowfish.c for more information about this file.
*/
  
#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  unsigned long P[16 + 2];
  unsigned long S[4][256];
} BLOWFISH_CTX;

void Blowfish_Init(BLOWFISH_CTX *ctx, unsigned char *key, int keyLen);
void Blowfish_Encrypt(BLOWFISH_CTX *ctx, unsigned long *xl, unsigned long *xr);
void Blowfish_Decrypt(BLOWFISH_CTX *ctx, unsigned long *xl, unsigned long *xr);


#ifdef __cplusplus
}
#endif

#endif

