# Originally created by John Murga (cf. http://gcc.gnu.org/ml/java/2003-01/msg00299.html)
# Adapted by Mohan Embar (http://www.thisiscool.com/) for GCC 3.3
# Check that we appear to have set the environment up

. buildenv.sh

if [ ! -d $WINGCC_DIR ]
then
    echo Setting up Windows compiler build directory...

    mkdir $WINGCC_DIR
    cd $WINGCC_DIR
    mkdir mingw32
    cd mingw32

    tar xfz $SUPP_SOURCES_DIR/$MINGWRT_TAR_GZ
#   unzip $SUPP_SOURCES_DIR/mingw-runtime-2.4-scandir.zip
    tar xfz $SUPP_SOURCES_DIR/$W32API_TAR_GZ
fi

# If GCC isn't configured this make sure it is all set-up ready for a "make"

if [ ! -d $WINGCC_BUILD_DIR ]
then
    echo Setting up Windows gcc build directory...
    mkdir $WINGCC_BUILD_DIR
    cd $WINGCC_BUILD_DIR
    sh $BUILD_SCRIPTS_DIR/cfgwingcc.sh
fi

# If all else has been done the only thing this script will do is attempt to
# make GCC, this way if you have applied any patches it'll incorporate them.

echo "About to build Windows GCC... <<Press enter>>"
read dummyVar

cd $WINGCC_BUILD_DIR
sh $BUILD_SCRIPTS_DIR/mkwingcc.sh

echo
echo "All done !"
